"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.renderToString = renderToString;
var _nodeWebStreamsHelper = require("../node-web-streams-helper");
var _constants = require("../lib/trace/constants");
var _tracer = require("../lib/trace/tracer");
let ReactDOMServer;
if (process.env.NEXT_PREBUNDLED_REACT === "experimental") {
    ReactDOMServer = require("next/dist/compiled/react-dom-experimental/server.browser");
} else {
    ReactDOMServer = require("next/dist/compiled/react-dom/server.browser");
}
async function renderToString(element) {
    return (0, _tracer).getTracer().trace(_constants.AppRenderSpan.renderToString, async ()=>{
        const renderStream = await ReactDOMServer.renderToReadableStream(element);
        await renderStream.allReady;
        return (0, _nodeWebStreamsHelper).streamToString(renderStream);
    });
}

//# sourceMappingURL=render-to-string.js.map